
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>在MFC程序中显示 JPG/GIF图像 / iVAN</title>

    <meta name="description" content="在MFC程序中显示 JPG/GIF图像 如果你是一个使用VB编程的程序员,要在程序中显示JPG或者GIF图像简直易如反掌,将图像控件拖到Form中,分分钟即可搞掂.但是C++程序员要显  示同样的图形却没有那么轻松,那么是不是要自己编写JPG解压缩代码呢?当然不用那么复杂啦!本文将针对这个问题讨论如何在MFC中显示JPG或者GIF 图像. 用VB写图像显示程序之所以如此轻松,完全是利用了琳琅满目的图像处理控件,把你想要做的事情都一一搞掂.而C++程序员为了实现相同的功能必须忙 乎半 天.其实,C/C++程序员也能使用那些VB程序员所用">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">在MFC程序中显示 JPG/GIF图像</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>如果你是一个使用VB编程的程序员，要在程序中显示JPG或者GIF图像简直易如反掌，将图像控件拖到Form中，分分钟即可搞掂。但是C++程序员要显  示同样的图形却没有那么轻松，那么是不是要自己编写JPG解压缩代码呢？当然不用那么复杂啦！本文将针对这个问题讨论如何在MFC中显示JPG或者GIF 图像。</p>
<p>用VB写图像显示程序之所以如此轻松，完全是利用了琳琅满目的图像处理控件，把你想要做的事情都一一搞掂。而C++程序员为了实现相同的功能必须忙 乎半 天。其实，C/C++程序员也能使用那些VB程序员所用的（或者说几乎一样的）图像控件。VB用的图像控件实际上都基于一个系统级COM类—— IPicture。下面是有关 IPicture 的方法描述：</p>
<table>
<tbody>
<tr>
<td>方法</td>
<td>描述</td>
</tr>
<tr>
<td>get_Handle </td>
<td>返回图像对象的Windows GDI句柄 </td>
</tr>
<tr>
<td>get_Hpal </td>
<td>返回图像对象当前使用的调色板拷贝</td>
</tr>
<tr>
<td>get_Type</td>
<td>返回当前图像对象的的图像类型</td>
</tr>
<tr>
<td>get_Width </td>
<td>返回当前图像对象的图像宽度</td>
</tr>
<tr>
<td>get_Height </td>
<td>返回当前图像对象的图像高度</td>
</tr>
<tr>
<td>Render </td>
<td>在指定的位置、指定的设备上下文上绘制指定的图像部分</td>
</tr>
<tr>
<td>set_Hpal </td>
<td>设置当前图像的调色板</td>
</tr>
<tr>
<td>get_CurDC </td>
<td>返回当前选中这个图像的设备上下文</td>
</tr>
<tr>
<td>SelectPicture </td>
<td>将一个位图图像选入给定的设备上下文，返回选中图像的设备上下文和图像的GDI句柄</td>
</tr>
<tr>
<td>get_KeepOriginalForma </td>
<td>返回图像对象KeepOriginalFormat 属性的当前值</td>
</tr>
<tr>
<td>put_KeepOriginalFormat </td>
<td>设置图像对象的KeepOriginalFormat 属性</td>
</tr>
<tr>
<td>PictureChanged </td>
<td>通知图像对象它的图像资源改变了</td>
</tr>
<tr>
<td>SaveAsFile </td>
<td>将图像数据存储到流中，格式与存成文件格式相同</td>
</tr>
<tr>
<td>get_Attributes </td>
<td>返回图像位属性当前的设置</td>
</tr>
</tbody>
</table>
<p>从上面这个表可以看出，IPicture操纵着图像对象及其属性。图像对象提供对位图的抽象，而Windows负责BMP、JPG和GIF位图的标 准实 现。程序员要做的只是实例化IPicture，然后调用其Render函数。与通常使用接口的方式不同，这里实例的创建我们不用 CoCreateInstance函数，而是用一个专门的函数OleLoadPicture。</p>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>IStream* pstm = // 需要一个流（stream） </li>
<li>IPicture* pIPicture; </li>
<li>hr = OleLoadPicture(pstm, 0, FALSE, IID_IPicture, (void**)&amp;pIPicture);       </li>
<li>OleLoadPicture从流中加载图像并创建一个可用来显示图像的新IPicture对象。 </li>
</ol>
<p>IStream* pstm = // 需要一个流（stream）<br />
IPicture* pIPicture;<br />
hr = OleLoadPicture(pstm, 0, FALSE, IID_IPicture, (void**)&amp;pIPicture);<br />
OleLoadPicture从流中加载图像并创建一个可用来显示图像的新IPicture对象。
<pre>rc = // 显示图像的矩形
// 将rc 转换为 HIMETRIC
spIPicture-&gt;Render(pDC, rc);      </pre>
<p>IPicture 负责处理所有琐事，以便确定图形之格式，如 Windows 位图、JPEG或者GIF文件——甚至是图标和元文件（metafiles）。当然啦，所有这些的实现细节是需要技巧的，为此我写了一个Demo程序 Myimgapp(如下图)来示范这些IPicture的使用方法。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZmlsZXMuaGVsbG9jcHAubmV0L0F0dGFjaG1lbnRzLzIwMDktNC8yOS84ODlkZjg3MzJiNjQ0ZTA1YjEzNDhkYTYzMWM2Nzg4NC5qcGc=.jpg"></p>
<p>Myimgapp是个典型的MFC文档/视图程序，在编写这个程序之前，我首先对 IPicture  COM接口进行封装，之所以要这么做，主要是考虑到并不是每一个程序员都能熟练运用COM接口进行编程，另外将IPicture的主要功能封装在C++类 中可以使我们的问题更容易解决，我封装的这个C++类名字叫做CPicture。它的定义和实现细节请参考本文提供的源代码。</p>
<p>我在这个类中将复杂而陌生的COM风格的参数映射成MFC程序员更为熟悉的类型。例如，CPicture可以让你直接从文件名加载一幅图 像，CFile或  者CArchive，而不用去处理流，CPicture::Render替你完成了IPicture中所有令人讨厌的但又是必须的HIMETRIC平滑转 换工作。CPicture甚至具备了一个Load函数，它可以从资源数据中加载图像，所以你只要用下面的代码就可以显示资源中的图像：</p>
<pre></pre>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>CPicture pic(ID_MYPIC); // 加载图像</li>
<li>CRect rc(0,0,0,0);      // 使用缺省的rc</li>
<li>pic.Render(pDC, rc);    // 显示图像</li>
</ol>
<p>CPicture pic(ID_MYPIC); // 加载图像<br />
   CRect rc(0,0,0,0);      // 使用缺省的rc<br />
   pic.Render(pDC, rc);    // 显示图像</p>
<p>CPicture::Render提供一个显示图片的矩形。IPicture 对图像进行延伸处理。如果传递一个空矩形，则CPicture用图像本身的大小--不进行延伸处理。对于图像本身而言，CPicture查  找"IMAGE"类型的资源，所以在资源文件中你必须要加入下面的代码：</p>
<pre></pre>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>IDR_MYPIC IMAGE MOVEABLE PURE "res//MyPic.jpg"</li>
</ol>
<p>IDR_MYPIC IMAGE MOVEABLE PURE "res//MyPic.jpg"<br />
<br />CPicture是个很棒的傻瓜类，它具备一个 ATL 智能指针CComQIPtr指向IPicture接口，通过调用OleLoadPicture来初始化不同的Load函数。CPicture提供了常用的 打包函数来调用底层的 IPicture。CPicture只封装了那些在Demo例子程序中要用到的方法。如果你需要调用IPicture::get_Handle或其它一些 很少用到的IPicture方法，你可以自己尝试编写相应的打包代码。  另外，在编写完CPicture之后，我发现了一个现成的MFC类——CPictureHolder，这个类的功能几乎与CPicture完全一样，你可 以在afxctl.h文件中找到它的定义。  前面说过，Demo例子是个典型的MFC文档/视图应用程序，因此它肯定少不了与文档和视图类相对应的CPictureDoc 和CPictureView：</p>
<p>CPictureDoc类没有什么特别的处理代码，它用CPicture对象存储图像：</p>
<pre></pre>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>class CPictureDoc : public CDocument {</li>
<li>protected:</li>
<li>CPicture m_pict; // the picture</li>
<li>};</li>
</ol>
<p>class CPictureDoc : public CDocument {<br />
protected:<br />
  CPicture m_pict; // the picture<br />
};</p>
<p>并且CPictureDoc::Serialize 调用CPicture::Load 从MFC存档的数据中读取图像。</p>
<pre></pre>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>void CPictureDoc::Serialize(CArchive&amp; ar)</li>
<li>{</li>
<li>if (ar.IsLoading()) {</li>
<li>m_pict.Load(ar);</li>
<li>}</li>
<li>}</li>
</ol>
<p>void CPictureDoc::Serialize(CArchive&amp; ar)<br />
{<br />
  if (ar.IsLoading()) {<br />
    m_pict.Load(ar);<br />
  }<br />
}</p>
<p>为了使Myimgapp程序更实用，CPictureDoc::OnNewDocument从程序资源数据加载了一幅图像。为了显示这幅图  像，CPictureView::OnDraw要调用CPicture::Render。这样程序一启动便会显示一幅默认的图像。</p>
<pre></pre>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>void CPictureView::OnDraw(CDC* pDC)</li>
<li>{</li>
<li>CPictureDoc* pDoc = GetDocument();</li>
<li>CPicture* ppic = pDoc-&gt;GetPicture();</li>
<li>CRect rc;</li>
<li>GetImageRect(rc);</li>
<li>ppic-&gt;Render(pDC,rc);</li>
<li>}</li>
</ol>
<p>void CPictureView::OnDraw(CDC* pDC)<br />
{<br />
  CPictureDoc* pDoc = GetDocument();<br />
  CPicture* ppic = pDoc-&gt;GetPicture();<br />
  CRect rc;<br />
  GetImageRect(rc);<br />
  ppic-&gt;Render(pDC,rc);<br />
}</p>
<p>GetImageRect是CPictureView类的一个成员函数，作用是根据当前Myimgapp的缩放比率（可用25%、33%、50%、 75%、100%或自适应方式）获取图像矩形。GetImageRect调用CPicture::GetImageSize来获得真正的图像大小，然后根 据比率显示。 CPictureView其余的部分完全和CScrollView的做法差不多，初始化视图并设置滚动大小，处理命令等等。唯一让人操心的是 IPicture::Render中HIMETRIC的处理问题，因为标准的MFC应用程序都使用MM_TEXT映射模型。不用担  心，CPicture::Render和CPicture::GetImageSize会将这一切转换过来，所以你不必为这些事情伤神。 CPictureView有一个消息处理器值得一提：它就是OnEraseBkgnd，当要显示的图像比客户区小的时候，这个函数必须绘制空白区域，如下 图，OnEraseBkgnd创建一个与图像大小相等的切边（clip）矩形，然后将客户区填成黑色。之所以要创建切边矩形，主要是避免当改变窗口大小时 出现的抖动——FillRect不绘制切边矩形内的区域，此乃Windows图形处理的常识。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZmlsZXMuaGVsbG9jcHAubmV0L0F0dGFjaG1lbnRzLzIwMDktNC8yOS82YjNlMDRhOTgxOGU0ZTc1YTAyYzg0ZGRkOTNkZTRkMS5qcGc=.jpg"></p>
<p>IPicture/CPicture简化了图像的显示。它甚至可以实现调色板的识别这样复杂的处理。你完全可以抛开老式DIB 图像绘制方法，如加载调色板、BitBlts、StretchBlts等等——这一切IPicture全都可以搞掂。如果你未曾用IPicture显示过 图像，那么现在试试吧。 CPictureView完成图像浏览的任务看来不是什么难事了。但是如果要把一幅图像添加到一个对话框或者其它的什么窗口中怎么办呢？为此我创建了另外 一个类——CPictureCtrl。 CPictureCtrl 使你可以在任何对话框或窗口中把图像作为子窗口显示。例如：</p>
<pre></pre>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/wangningyu/article/details/5618878#" rel="external nofollow noreferrer">?</a></p>
<ol>
<li>class CAboutDialog : public CDialog {</li>
<li>protected:</li>
<li>CPictureCtrl m_wndPict;</li>
<li>virtual BOOL OnInitDialog();</li>
<li>};</li>
<li>BOOL CAboutDialog::OnInitDialog()</li>
<li>{</li>
<li>m_wndPict.SubclassDlgItem(IDC_MYIMAGE,this);</li>
<li>return CDialog::OnInitDialog();</li>
<li>}</li>
</ol>
<p>class CAboutDialog : public CDialog {<br />
protected:<br />
  CPictureCtrl m_wndPict;<br />
  virtual BOOL OnInitDialog();<br />
};<br />
BOOL CAboutDialog::OnInitDialog()<br />
{<br />
  m_wndPict.SubclassDlgItem(IDC_MYIMAGE,this);<br />
  return CDialog::OnInitDialog();<br />
}<br />
<br />假设你的对话框中有一个静态控制，它的ID=IDC_IMAGE，并且有一幅IMAGE资源的ID与之相同。则从CStaticLink派生出的 CPictureCtrl还可以指定一个URL超链接（或者创建一个ID与此控制或图像的ID相同的串资源）。如果你指定了一个URL，则在图像上单击鼠 标将启动默认浏览器访问URL。真是酷呆了。CPicture控制着CPicture对象并改写WM_PAINT消息处理例程，调用 CPicture::Render代替通常的静态控制处理例程。处理细节请参见代码。打开Myimgapp程序的“关于”对话框就知道了。</p>
<p>原文地址：<a href="http://www.hellocpp.net/Articles/Article/340.aspx" rel="external nofollow noreferrer">http://www.hellocpp.net/Articles/Article/340.aspx</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 14:48:21</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/mfc/" title="mfc">mfc</a>, <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f%e5%91%98/" title="程序员">程序员</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/view/" title="view">view</a>, <a href="https://www.iamivan.net/tag/render/" title="render">render</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>在MFC程序中显示 JPG/GIF图像的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd7XWAM.html" rel="bookmark">在MFC应用程序中显示JPG&sol;GIF图像文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果你是一个使用Visual Basic编程的程序员,要在程序中显示JPG或者GIF图像简直易如反掌,将图像控件拖到Form中就可以了.但是C++程序员要显示同样格式的图像文件却没有那么轻松,那么是不是要自己编写JPG解压缩代码呢?当然不用那么复杂啦!本实例将针对这个问题讨论如何在MFC中显示JPG或者GIF格式的图像文件. 一.实现方法 用Visual Basic写图像显示程序之所以如此轻松,完全是利用了琳琅满目的图像处理控件,它们处理了显示图像文件的所有底层工作,而C++程序员为了实现相同的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3Na9gz.html" rel="bookmark">在你的MFC应用程序中显示一个JPG文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在VB中,我可以通过创建一个图像控件来显示一个JPG或GIF文件,但是我如何在我的MFC应用程序中显示一个JGP文件呢? 好问题!有时使用VB的程序员觉得这个很容易.只要往你的表中拖入一个图像控件,然后你就可以往下做了--然而C++程序员就不得不感到烦恼和头疼.那我们要做些什么呢,编写我们自己的JPG解压函数吗? 当然不是这样的!事实上,C/C++程序员能够使用与VB程序员所使用的非常类似(可以说是差不多)的图像控件.我并没有开玩笑.VB图像控件是基于一个叫&quot;IPicture&quot;的系统C			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd6kx1b.html" rel="bookmark">界面-如何使打开的其他程序或者文档在MFC窗口中显示，而不是新打开一个窗口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如何使打开的其他程序或者文档在MFC窗口中显示,而不是新打开一个窗口 我想在程序界面中指定一个区域,用于显示被打开的其他程序或者文档的界面.可是我用ShellExecute函数打开指定的那个文档和程序的时候,总是会再启动另一个窗口,效果就像是直接点击打开那个文件一样. 解决方案 将mfc窗口设置为其它程序的父窗口 解决方案二: 参考:程序只允许打开唯一实例且所有关联文档都在同一实例内打开的一揽子解决办法http://blog.csdn.net/IfI/article/details/1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNEdnPb.html" rel="bookmark">从WinForm程序中显示WPF Window出现&OpenCurlyDoubleQuote;The URI prefix is not recognized&rdquo;异</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从WinForm程序中显示WPF Window出现&quot;The URI prefix is not recognized&quot;异常的解决方法 从WinForm App中显示WPF窗口的代码: MyWindow wpfWindow = new MyWindow(); WindowInteropHelper wih = new WindowInteropHelper(wpfWindow); wih.Owner = ownerHwnd; wpfWindow.ShowDialog(); 一般情况下,这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqLY2Kb.html" rel="bookmark">在非MFC程序中引用CString</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CString在当今软件设计界里还是小有名气的,说它是MFC中使用的最多的类一点也不过,然而在使用sdk编windows程序的时候,确不能利用CString类,只能用sdk的运行时库,比如strlen,strcpy,strstr等等,本文讨论的是在非mfc程序中使用CString类的方法,算是个引子,如果有更好的实现方法,欢迎大家讨论. 为了使用CString类,首先源文件必须是以cpp结尾的,这是因为vc默认对不同的扩展名采用不同的编译方法和错误检查,mfc的支持文件Afx.h只有由cpp为扩			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7ZkVKp.html" rel="bookmark">mfc求助-在mfc程序中，如何使程序和文档关联起来？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在mfc程序中,如何使程序和文档关联起来? 我是一名刚学软件不久的学生,最近在做一个项目,有很多地方不明白,还望大家赐教! 我想做一个文档备份器,但是不知道如何使mfc程序和文档关联起来,即当在某些文档中输入消息时,程序会收到输入相应的消息(输入消息的间隔时间,输入内容,等等) 望各位大神赐教! 谢谢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnRnWKp.html" rel="bookmark">mfc windows编程-怎么才可以让mfc框架中显示出图片</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 怎么才可以让mfc框架中显示出图片 如图所示,我看视频学的,写的也和视频中一样,可为什么图片总是显示不出来,是因为m_img没有赋值成功么,希望大神们指导,最好能写下源码.对了,我建立mfc.exe时,里面的什么头文件啊什么的,就加了一个Gdiplus.h,其他的什么定义也没动,只是加了一些东西,求教多谢各位大神 解决方案 http://blog.csdn.net/friendan/article/details/38358507http://blog.csdn.net/liu_che			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK30Ynb.html" rel="bookmark">&lbrack;请教&rsqb;计算机中不装MS Word可以在程序中显示和操作&period;doc文档吗？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 就是说本地计算机中不安装微软的Word程序,但是可以在本地计算机的程序中显示和操作word的.doc文档,有这样的插件和方案吗??本人写了一个调用word程序来显示和处理word文档的程序,但是客户嫌使用这个程序要先装word很麻烦,所以希望不装word就能在本人的程序中显示和处理word文档,不知道是否有高手做过类似的东西,提供个思路也行,拜谢!!! 解决方案 解决方案二:网上找找看有没有第三方控件支持,支持显示的应该能找到,支持编辑的可能就比较难找了解决方案三:好像没有什么特别好的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDAP0vb.html" rel="bookmark">在MFC程序中添加全屏显示功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这是工作室为实现全屏显示所发集的一个演示程序.你可以通过选择全屏显示菜单选项时看到相应的效果.这段代码包括两个内容:全屏显示,浮动工具条(用于恢复操作). 下图便是全屏状态和用于切换的浮动工具条 具体实现步骤: 以下的代码被添加到CmainFrame类中.这里是使用到的四个消息以及他们的简要说明: 1．OnViewFullScreen:全屏显示菜单项的句柄. 2．OnGetMinMaxInfo:捕获 WM_GETMINMAXINFO消息来让你改变窗体大小. 3．IsFullScreen:测试程序			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlK1Rb.html" rel="bookmark" class="title">20种PS技术 淘宝新手必学</a>
					<div>
						一种简单的数码照片后期润饰 1 打开图片,执行色像/饱和度(-40)降低饱和度. 2 新建一图层,将图层模式改为柔光,用画笔工具将需要润饰的部分画几下,这里可以利用色板方便的提取颜色 3 图片色彩过渡 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAq0ZM.html" rel="bookmark" class="title">&lbrack;学习笔记&rsqb;Thinking in Java &lpar;the 2nd edition&rpar; Study Note &lpar;3&rpar;</a>
					<div>
						笔记 第9章 违例差错控制 Java的基本原理就是&quot;形式错误的代码不会运行&quot;.&lt;1&gt;在Java中,对那些要调用方法的客户程序员,我们要通知他们可能从自己的方法里&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp546AM.html" rel="bookmark" class="title">对周鸿祎用户体验阐释的简单理解</a>
					<div>
						曾几何时,奇人周鸿祎对用户体验作出了自己的理解:&quot;要超出用户预期,能够给用户带来惊喜;要能够让用户有所感知;好的用户体验,是从细节开始,并贯穿于每一个细节.&quot;对于这一经典阐释,每个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9wWgz.html" rel="bookmark" class="title">Java&period;next：下一代的JVM语言</a>
					<div>
						本文是ThoughtWorks公司架构师Neal Ford在IBM developerWorks系列文章java.next中的第一篇,其基于Groovy,Scala和Clojure,讲述了多语言编程的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEjPJb.html" rel="bookmark" class="title">Vista资源管理器特点分析&lpar;1&rpar;</a>
					<div>
						Windows Vista中增加了很多新功能,同时一些老的组件也得到了加强,资源管理器就是其中之一.老实说,老版本Windows自带的资源管理器并不好用,无论是文件的显示.查找还是定位都不太方便,以至 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRy27kb.html" rel="bookmark" class="title">部分网页无法正常打开解决方法</a>
					<div>
						  解决办法 使用其他电脑,或是让其他朋友访问这些自己无法访问的网址,如果他们也都无法打开,就有可能是网站服务器短皙性故階,一般情况下,过一段时间会自动恢复.如果非网站本身问题,则需要从以下几方面着手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w8YPp.html" rel="bookmark" class="title">利用PS通道替换打造淡调唯美紫红色外景照片</a>
					<div>
						紫红色也是双色图片,用通道替换是最快的.不过通道替换之前需要简单分析图片中的冷暖色的比例,如果比例不是很均匀,需要用调色工具增加相应的颜色. 原图 &lt;点小图查看大图&gt; 最终效果 1.打开素 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o76Wb.html" rel="bookmark" class="title">OS X Yosemite系统怎么制作u盘安装盘？</a>
					<div>
						  OS X Yosemite系统已经正式发布提供下载了,本文小编就来教一下大家OS X Yosemite系统怎么制作u盘安装盘. 需要通过系统验证,所以你只有制作启动U盘的方法来升级到 OS X 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kxZlM.html" rel="bookmark" class="title">linux之线程</a>
					<div>
						http://blog.csdn.net/lanyan822/article/details/7586845  POSIX线程数据类型: pthread_t 线程标识符: pthread_mutex_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGANZvM.html" rel="bookmark" class="title">面试之如何回答关于算法设计的问题？</a>
					<div>
						转自:http://blog.csdn.net/xdhehao/article/details/12522449                                             ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32L5gz.html" rel="bookmark" class="title">分享一个原创的eclipse插件：Easy Middle Button</a>
					<div>
						问题描述 看到csdn这里的eclipse版也挺活跃,来分享一个我原创的eclipse插件吧.插件的名称是EasyMiddleButton,主要功能是用鼠标中键来调整编辑器或者视图的大小.当显示器不是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEj3qp.html" rel="bookmark" class="title">java用编写一个4&ast;4矩阵程序，并要求行列能够互换</a>
					<div>
						问题描述 java用编写一个4*4矩阵程序,并要求行列能够互换 各位大神帮帮忙,请编写一个程序,要求能够对一个4*4的矩阵进行行列互换,非常感谢! 解决方案 public static void ma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0BmYM.html" rel="bookmark" class="title">花花公子拍摄专题摄影作品 性感女郎致意《Tron》经典科幻电影</a>
					<div>
						&lt;创:战纪(Tron: Legacy)&gt;即将在12月17日上映,这部时尚酷爆的3D电影还未上映就已经引起了不小的轰动,就连Playboy也来凑热闹.Playboy本次找来两位身材火辣的性感 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z1XRz.html" rel="bookmark" class="title">草根创业者自媒体明星之路</a>
					<div>
						1.人脉 在网上做网赚,就要广交朋友,多学习.不要总在qq群里吓扯淡.其实我想到一点,你的能力决定了你所结交的朋友的能力.你的能力越强,你的圈子里的人的能力就越强.如果你是个菜鸟,并且是个不愿意去学习 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJJ15p.html" rel="bookmark" class="title">Java反射探索研究（转）</a>
					<div>
						         林炳文Evankaka原创作品.转载请注明出处http://blog.csdn.net/evankakay           摘要:本文详细深入讲解是Java中反射的机制,并介绍了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22ZrBb.html" rel="bookmark" class="title">天猫电器城升级服务：快递迟到即免单</a>
					<div>
						新浪科技讯 5月15日上午消息,3C电器类电商价格战已经进入到如火如荼的阶段,天猫 电器城再从服务角度升级,推出次日达迟到 免单.天猫电器城宣布,将在5月24日--27日的五大品牌联合促销中试行22城 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xWr4b.html" rel="bookmark" class="title">互联网&plus;时代医疗信息化探索与思考</a>
					<div>
						本文讲的是互联网+时代医疗信息化探索与思考,伴随整个医疗产业以及医改的发展,可以看出今天的信息化在医院中已经变得至关重要.随着互联网的普及以及发展,以移动.大数据.云计算为主的新一代信息技术正在逐步的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWW3QqM.html" rel="bookmark" class="title">javaweb-页面有多行类似的radio标签，怎么把选中的值保存到数据库中</a>
					<div>
						问题描述 页面有多行类似的radio标签,怎么把选中的值保存到数据库中 如图,怎么将选中的radio值保存到数据中 解决方案 http://bbs.csdn.net/topics/370025018  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJoNWp.html" rel="bookmark" class="title">学习SEO一定要从观察开始</a>
					<div>
						摘要: 有多少人想学习SEO不知道从哪里开始的?有多少是从论坛学习基本知识开始的?学会了之后发现还是不知道从哪里下手.哦不对,就知道从,外链.文章.友情链接下手.我不能说这样 有多少人想学习SEO不知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvnk28M.html" rel="bookmark" class="title">微软炫耀斯巴达浏览器&comma;原生支持Chrome浏览器扩展</a>
					<div>
						1月21日是微软的大日子,微软在那天向外界揭示了 Windows 10消费者预览版,并且炫耀新的斯巴达浏览器.根据Neowin网站报道,斯巴达浏览器将原生支持Chrome浏览器扩展,以提升斯巴达浏览器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8X9Kb.html" rel="bookmark" class="title">PHP中empty和isset对于参数结构的判断及empty&lpar;&rpar;和isset&lpar;&rpar;的区别&lowbar;php实例</a>
					<div>
						废话不多说了,直接给大家贴代码了. &lt;?php class test{} $a1 = null; $a2 = &quot;&quot;; //$a3 = $a4 = 0; $a5 = '0';  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWEgkz.html" rel="bookmark" class="title">php字符串分割函数explode的实例代码&lowbar;php技巧</a>
					<div>
						array explode (string $separator, string $string [, int $limit]) 该函数有3个参数,第一个参数$separator设置一个分割字符(串) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Q4maM.html" rel="bookmark" class="title">百度大更新让我们做出了什么改变</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在6.22到6.28这段时间,百度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2OA6M.html" rel="bookmark" class="title">linux下执行Runtime&period;getRuntime&lpar;&rpar;&period;exec出错</a>
					<div>
						问题描述 linux系统下使用如下命令进行打开:Stringaddr=&quot;/u01/pages/excel/performancekong2011.xls&quot;;Runtime.getR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GX2op.html" rel="bookmark" class="title">confluence 官网下载问题</a>
					<div>
						问题描述 confluence在官网下载linux总是不成功,要么是版本选择的页面无法完整显示,要么就是点击下载后显示空白页或者是提示无效链接.怎么回事,还有没有可以用的官方下载链接啊??? 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmR7J1z.html" rel="bookmark" class="title">《HFSS电磁仿真设计从入门到精通》一1&period;1 HFSS简介</a>
					<div>
						1.1 HFSS简介 HFSS电磁仿真设计从入门到精通HFSS是美国Ansoft公司开发的全波三维电磁仿真软件,该软件采用有限元法,计算结果准确可靠,是业界公认的三维电磁场设计和分析的工业标准. HF ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOW5akz.html" rel="bookmark" class="title">Windows Phone负责人居然在用iPhone？其实这并不奇怪</a>
					<div>
						关注微软和Windows Phone的人应该知道,Joe Belfiore算得上是Windows Phone的门面,他是微软操作系统团队的企业副总裁,负责Windows Phone设计和软件产品.但比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wKDAz.html" rel="bookmark" class="title">使用百度手机助手的免费wifi服务</a>
					<div>
						钻研移动.联通.电信各种流量套餐,把每KB流量费用精确到小数点后四位:流连于麦当劳.星巴克各种蹭网--为省手机流量,大家至于这么拼么?在机智的智能手机达人眼里,只需一招即可摆脱流量困扰轻松做土豪,那就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baqjdwb.html" rel="bookmark" class="title">《3D打印就这么简单》&mdash;&mdash;3&period;2节组装初期的经验之谈</a>
					<div>
						3.2 组装初期的经验之谈3D打印就这么简单最初几个步骤是组装 Simple的基座.读者将看到怎样将轴承安装到一片较大的激光切割的板块上.轴承稍感油腻,因为上面有润滑油.将金属杆穿过轴承,润滑油应能够 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPONL1M.html" rel="bookmark" class="title">ehcache&period;xml设置（转）</a>
					<div>
						&lt;ehcache xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot; xsi:noNamespaceSchemaLoc ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
